"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = renderMain;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _global = require("global");

var _commonTags = require("common-tags");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n        Did you forget to return the HTML snippet from the story?\n        Use \"() => <your snippet or node>\" or when defining the story.\n      "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var rootElement = _global.document.getElementById('root');

var headElement = _global.document.head;
var bodyElement = _global.document.body;

function renderMain(_ref) {
  var story = _ref.story,
      selectedKind = _ref.selectedKind,
      selectedStory = _ref.selectedStory,
      showMain = _ref.showMain,
      showError = _ref.showError,
      forceRender = _ref.forceRender;
  var component = story();
  var isDom = component instanceof HTMLElement;

  var styleElement = _global.document.getElementById('sb-component-style');

  var scriptElement = _global.document.getElementById('sb-component-script');

  if (styleElement) {
    styleElement.parentNode.removeChild(styleElement);
  }

  if (scriptElement) {
    scriptElement.parentNode.removeChild(scriptElement);
  }

  showMain();

  if ((0, _typeof2.default)(component) === 'object' && !isDom) {
    var template = component.template,
        styles = component.styles,
        scripts = component.scripts; // Add costom style

    if (styles) {
      var _styleElement = _global.document.createElement('style');

      _styleElement.setAttribute("id", "sb-component-style");

      _styleElement.innerHTML = styles;
      headElement.appendChild(_styleElement);
    }

    if (template) {
      rootElement.innerHTML = template.innerHTML || template;
    } // Add costom script


    if (scripts) {
      var _scriptElement = _global.document.createElement('script');

      _scriptElement.setAttribute("id", "sb-component-script");

      _scriptElement.innerHTML = scripts;
      bodyElement.appendChild(_scriptElement);
    }
  } else if (typeof component === 'string') {
    rootElement.innerHTML = component;
  } else if (component instanceof _global.Node) {
    if (forceRender === true) {
      return;
    }

    rootElement.innerHTML = '';
    rootElement.appendChild(component);
  } else {
    showError({
      title: "Expecting an HTML snippet or DOM node from the story: \"".concat(selectedStory, "\" of \"").concat(selectedKind, "\"."),
      description: (0, _commonTags.stripIndents)(_templateObject())
    });
  }
}