"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withScripts = exports.withStyles = void 0;

var _addons = _interopRequireWildcard(require("@storybook/addons"));

var INNER_ID = 'sb-addon-handlebars-inner';
var WRAPPER_ID = 'sb-addon-handlebars-wrapper';
var iframeHead = document.head;
var iframeBody = document.body;
var storyNameCache = new URL(location.href).searchParams.get('selectedKind');
var withScripts = (0, _addons.makeDecorator)({
  name: 'withScripts',
  parameterName: 'Scripts',
  skipIfNoParametersOrOptions: true,
  wrapper: function wrapper(getStory, context, _ref) {
    var options = _ref.options,
        parameters = _ref.parameters;
    var scripts = parameters || options || [];
    var storyName = context.kind;
    if (!scripts) return getStory(context);
    var body = iframeBody;
    var scriptElement = document.getElementById("story-".concat(storyName.toLowerCase(), "-script"));

    if (!scriptElement) {
      scriptElement = document.createElement('script');
      scriptElement.setAttribute('id', "story-".concat(storyName.toLowerCase(), "-script"));
      body.appendChild(scriptElement);
    }

    scriptElement.innerHTML = scripts.script;
    return getStory(context);
  }
});
exports.withScripts = withScripts;
var withStyles = (0, _addons.makeDecorator)({
  name: 'withStyles',
  parameterName: 'Styles',
  skipIfNoParametersOrOptions: true,
  wrapper: function wrapper(getStory, context, _ref2) {
    var options = _ref2.options,
        parameters = _ref2.parameters;
    var styles = parameters || options || [];
    var storyName = context.kind;
    if (!styles) return getStory(context);
    var head = iframeHead;
    var styleElement = document.getElementById("story-".concat(storyName.toLowerCase(), "-style"));

    if (!styleElement) {
      styleElement = document.createElement('style');
      styleElement.setAttribute('id', "story-".concat(storyName.toLowerCase(), "-style"));
      head.appendChild(styleElement);
    }

    styleElement.innerHTML = styles.style;
    return getStory(context);
  }
});
exports.withStyles = withStyles;